#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "struct.h"
#include "pcg.h"
#include "input.h"
#include "pointer_init.h"
#include "boundary_cell.h"
#include "cell_metrics.h"
#include "poi_gen.h"
#include "solver_ICCG.h"
#include "solver_ICCG2.h"
#include "solver_PCG.h"
#include "outucd.h"

int
main(int argc, char **argv)
{
	int ISET, ITR, IER;

/*********
 * INIT. *
 *********/
	if(INPUT()) goto error;
	if(POINTER_INIT()) goto error;
	if(BOUNDARY_CELL()) goto error;
	if(CELL_METRICS()) goto error;
	if(POI_GEN()) goto error;

/***************
 * MAIN SOLVER *
 ***************/
	memset(PHI, 0, sizeof(int)*ICELTOT);

	ISET = 0;

	if(METHOD == 1) {
		if(solve_ICCG(ICELTOT, NL, NU, INL, IAL, INU, IAU,
			D, BFORCE, PHI, AL, AU, EPSICCG, &ITR, &IER)) goto error;
	} else if(METHOD == 2) {
		if(solve_ICCG2(ICELTOT, NL, NU, INL, IAL, INU, IAU,
			D, BFORCE, PHI, AL, AU, EPSICCG, &ITR, &IER)) goto error;
	} else if(METHOD == 3) {
		if(solve_PCG(ICELTOT, NL, NU, INL, IAL, INU, IAU,
			D, BFORCE, PHI, AL, AU, EPSICCG, &ITR, &IER)) goto error;
	}

	if(OUTUCD()) goto error;

	return 0;

error:
	return -1;
}
