/*
 * RCM
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "cm.h"

extern int
CM(int N, int NL, int NU, int *INL, int **IAL, int *INU, int **IAU,
	int *NCOLORtot, int *COLORindex, int *NEWtoOLD, int *OLDtoNEW)
{
	int **IW;
    int *INLw, *INUw;
    int **IALw, **IAUw;
	int KC, KCT, KCT0, KMIN, KMAX;
	int JC, JN;
	int II;
	int i, j, k, ic;
	int INmin, NODmin;
	int icon, icol, icouG, icou, icou0, in, inC, jL, jU;

/*********
 * INIT. *
 *********/
	IW = (int **)calloc(2, sizeof(int *));
	if(IW == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<2; i++) {
		IW[i] = (int *)calloc(N, sizeof(int));
		if(IW[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	INmin  = N;
	NODmin = -1;

	for(i=0; i<N; i++) {
		icon = 0;
		for(k=0; k<INL[i]; k++) {
			icon++;
		}
		for(k=0; k<INU[i]; k++) {
			icon++;
		}

		if(icon < INmin) {
			INmin  = icon;
			NODmin = i;
		}
	}


	if(NODmin == -1) NODmin = 0;

	IW[1][NODmin] = 1;

	NEWtoOLD[0]      = NODmin;
	OLDtoNEW[NODmin] = 0;

	icol = 0;

/************
 * COLORING *
 ************/
	icouG = 1;
	for(icol=1; icol<N; icol++) {
		icou  = 0;
		icou0 = 0;
		for(i=0; i<N; i++) {
			if(IW[1][i] == icol) {
				for(k=0; k<INL[i]; k++) {
					in = IAL[i][k];
					if(IW[1][in-1] == 0) {
						IW[1][in-1] = -(icol + 1);
						icou++;
						IW[0][icou-1] = in;
					}
				}
				for(k=0; k<INU[i]; k++) {
					in = IAU[i][k];
					if(IW[1][in-1] == 0) {
						IW[1][in-1] = -(icol + 1);
						icou++;
						IW[0][icou-1] = in;
					}
				}
			}
		}

		if(icou == 0) {
			for(i=0; i<N; i++) {
				if(IW[1][i] == 0) {
					icou++;
					IW[1][i     ] = -(icol + 1);
					IW[0][icou-1] = i + 1;
					break;
				}
			}
		}

		for(ic=0; ic<icou; ic++) {
			inC = IW[0][ic];
			if(IW[1][inC-1] != 0) {
				for(k=0; k<INL[inC-1]; k++) {
					in = IAL[inC-1][k];
					if(IW[1][in-1] <= 0) {
						IW[1][in-1] = 0;
					}
				}
				for(k=0; k<INU[inC-1]; k++) {
					in = IAU[inC-1][k];
					if(IW[1][in-1] <= 0) {
						IW[1][in-1] = 0;
					}
				}
			}
		}

		for(ic=0; ic<icou; ic++) {
			inC = IW[0][ic];
			if(IW[1][inC-1] != 0) {
				icouG++;
				IW[1][inC-1] = icol + 1;
			}
		}

		if(icouG == N) break;
	}

/******************/
/* FINAL COLORING */
/******************/
	*NCOLORtot = icol + 1;
	icouG = 0;
	for(ic=1; ic<=(*NCOLORtot); ic++) {
		icou = 0;
		for(i=N-1; i>=0; i--) {
			if(IW[1][i] == ic) {
				NEWtoOLD[icouG] = i;
				OLDtoNEW[i    ] = icouG;
				icou++;
				icouG++;
			}
		}
		COLORindex[ic] = icou;
	}

	COLORindex[0] = 0;
	for(ic=1; ic<=(*NCOLORtot); ic++) {
		COLORindex[ic] = COLORindex[ic-1] + COLORindex[ic];
	}

/*******************/
/* MATRIX transfer */
/*******************/
    INLw = (int *)calloc(N, sizeof(int));
    if(INLw == NULL) {
 		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
    }

	INUw = (int *)calloc(N, sizeof(int));
	if(INUw == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}

	IALw = (int **)calloc(N, sizeof(int *));
	if(IALw == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<N; i++) {
		IALw[i] = (int *)calloc(NL, sizeof(int));
		if(IALw[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	IAUw = (int **)calloc(N, sizeof(int *));
	if(IAUw == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<N; i++) {
		IAUw[i] = (int *)calloc(NU, sizeof(int));
		if(IAUw[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	for(i=0; i<NL; i++) {
		for(j=0; j<N; j++) {
			IW[0][j] = IAL[NEWtoOLD[j]][i];
		}
		for(j=0; j<N; j++) {
			IAL[j][i] = IW[0][j];
		}
	}

	for(i=0; i<NU; i++) {
		for(j=0; j<N; j++) {
			IW[0][j] = IAU[NEWtoOLD[j]][i];
		}
		for(j=0; j<N; j++) {
			IAU[j][i] = IW[0][j];
		}
	}

	for(i=0; i<N; i++) {
		IW[0][i] = INL[NEWtoOLD[i]];
	}

	for(i=0; i<N; i++) {
		INLw[i] = IW[0][i];
	}

	for(i=0; i<N; i++) {
		IW[0][i] = INU[NEWtoOLD[i]];
	}

	for(i=0; i<N; i++) {
		INUw[i] = IW[0][i];
	}

	for(j=0; j<N; j++) {
		for(i=0; i<NL; i++) {
			if(IAL[j][i] == 0) {
				IALw[j][i] = 0;
			} else {
				IALw[j][i] = OLDtoNEW[IAL[j][i]-1] + 1;
			}
		}
	}

	for(j=0; j<N; j++) {
		for(i=0; i<NL; i++) {
			if(IAU[j][i] == 0) {
				IAUw[j][i] = 0;
			} else {
				IAUw[j][i] = OLDtoNEW[IAU[j][i]-1] + 1;
			}
		}
	}

	for(j=0; j<N; j++) {
		INL[j] = 0;
		INU[j] = 0;
		for(i=0; i<NL; i++) {
			IAL[j][i] = 0;
		}
		for(i=0; i<NU; i++) {
			IAU[j][i] = 0;
		}
	}

	for(j=0; j<N; j++) {
		jL = 0;
		jU = 0;
		for(i=0; i<INLw[j]; i++) {
			if(IALw[j][i] > j + 1) {
				IAU[j][jU] = IALw[j][i];
				jU++;
			} else {
				IAL[j][jL] = IALw[j][i];
				jL++;
			}
		}

		for(i=0; i<INUw[j]; i++) {
			if(IAUw[j][i] > j + 1) {
				IAU[j][jU] = IAUw[j][i];
				jU++;
			} else {
				IAL[j][jL] = IAUw[j][i];
				jL++;
			}
		}

		INL[j] = jL;
		INU[j] = jU;
	}

	free(IW);
	free(INLw);
	free(INUw);
	free(IALw);
	free(IAUw);

	return 0;
}
