/*
 * POI_GEN
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "struct_ext.h"
#include "pcg_ext.h"
#include "mc.h"
#include "cm.h"
#include "rcm.h"
#include "poi_gen.h"

extern int
POI_GEN(void)
{
	int nn, nnp;
	int ic0, icN1, icN2, icN3, icN4, icN5, icN6;
	int i, j, k, ib, ic, ip, icel, icou, icol, icouG;
	int ii, jj, kk, nn1, num, nr, j0, j1;
	double coef, VOL0, S1t, E1t;

	nn  = ICELTOT;

	NL = 6;
	NU = 6;

	BFORCE = (double *)malloc(nn * sizeof(double));
	if(BFORCE == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	D = (double *)malloc(nn * sizeof(double));
	if(D == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	PHI = (double *)malloc(nn * sizeof(double));
	if(PHI == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}

	INL = (int *)calloc(nn, sizeof(int));
	if(INL == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	INU = (int *)calloc(nn, sizeof(int));
	if(INU == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	IAL = (int **)calloc(nn, sizeof(int *));
	if(IAL == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<nn; i++) {
		IAL[i] = (int *)calloc(NL, sizeof(int));
		if(IAL[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}
	IAU = (int **)calloc(nn, sizeof(int *));
	if(IAU == NULL) {
		fprintf(stderr, "%s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<nn; i++) {
		IAU[i] = (int *)calloc(NU, sizeof(int));
		if(IAU[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	AL = (double **)malloc(nn * sizeof(double));
	if(AL == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<nn; i++) {
		AL[i] = (double *)malloc(NL * sizeof(double));
		if(AL[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}
	AU = (double **)malloc(nn * sizeof(double));
	if(AU == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<nn; i++) {
		AU[i] = (double *)malloc(NU * sizeof(double));
		if(AU[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	for(j=0; j<nn; j++) {
		D[j] = 0.0;
        PHI[j] = 0.0;
		for(i=0; i<NL; i++) {
			AL[j][i] = 0.0;
		}
		for(i=0; i<NU; i++) {
			AU[j][i] = 0.0;
		}
	}

/*********************************
 * INTERIOR & NEUMANN boundary's *
 *********************************/
	for(icel=0; icel<ICELTOT; icel++) {
		icN1 = NEIBcell[0][icel];
		icN2 = NEIBcell[1][icel];
		icN3 = NEIBcell[2][icel];
		icN4 = NEIBcell[3][icel];
		icN5 = NEIBcell[4][icel];
		icN6 = NEIBcell[5][icel];

		if(icN5 != 0) {
			icou = INL[icel] + 1;
			IAL[icel][icou-1] = icN5;
			INL[icel]         = icou;
		}

		if(icN3 != 0) {
			icou = INL[icel] + 1;
			IAL[icel][icou-1] = icN3;
			INL[icel]         = icou;
		}

		if(icN1 != 0) {
			icou = INL[icel] + 1;
			IAL[icel][icou-1] = icN1;
			INL[icel]         = icou;
		}

		if(icN2 != 0) {
			icou = INU[icel] + 1;
			IAU[icel][icou-1] = icN2;
			INU[icel]         = icou;
		}

		if(icN4 != 0) {
			icou = INU[icel] + 1;
			IAU[icel][icou-1] = icN4;
			INU[icel]         = icou;
		}

		if(icN6 != 0) {
			icou = INU[icel] + 1;
			IAU[icel][icou-1] = icN6;
			INU[icel]         = icou;
		}
	}

/*****************
 * MULTICOLORING *
 *****************/
	OLDtoNEW = (int *)calloc(ICELTOT, sizeof(int));
	if(OLDtoNEW == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	NEWtoOLD = (int *)calloc(ICELTOT, sizeof(int));
	if(NEWtoOLD == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	COLORindex = (int *)calloc(ICELTOT+1, sizeof(int));
	if(COLORindex == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}

N111:
	fprintf(stderr, "\n\nYou have%8d elements\n", ICELTOT);
	fprintf(stderr, "How many colors do you need ?\n");
	fprintf(stderr, "  #COLOR must be more than 2 and\n");
	fprintf(stderr, "  #COLOR must not be more than%8d\n", ICELTOT);
	fprintf(stderr, "   CM if #COLOR .eq. 0\n");
	fprintf(stderr, "  RCM if #COLOR .lt. 0\n");
	fprintf(stderr, "=>\n");

	if(NCOLORtot == 1 || NCOLORtot > ICELTOT) goto N111;

	if(NCOLORtot > 0) {
		MC(ICELTOT, NL, NU, INL, IAL, INU, IAU,
				&NCOLORtot, COLORindex, NEWtoOLD, OLDtoNEW);
		fprintf(stderr, "\n###  MultiColoring\n");
	} else if(NCOLORtot == 0) {
		CM(ICELTOT, NL, NU, INL, IAL, INU, IAU,
				&NCOLORtot, COLORindex, NEWtoOLD, OLDtoNEW);
		fprintf(stderr, "\n###  CM\n");
	} else if(NCOLORtot < 0) {
		RCM(ICELTOT, NL, NU, INL, IAL, INU, IAU,
				&NCOLORtot, COLORindex, NEWtoOLD, OLDtoNEW);
		fprintf(stderr, "\n###  RCM\n");
	}

	fprintf(stderr, "\n### FINAL COLOR NUMBER%8d\n\n", NCOLORtot);


	SMPindex = (int *)calloc(NCOLORtot*PEsmpTOT+1, sizeof(int));
	if(SMPindex == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(ic=1; ic<=NCOLORtot; ic++) {
		nn1 = COLORindex[ic] - COLORindex[ic-1];
		num = nn1 / PEsmpTOT;
		nr  = nn1 - PEsmpTOT * num;
		for(ip=1; ip<=PEsmpTOT; ip++) {
			if(ip <= nr) {
				SMPindex[(ic-1)*PEsmpTOT+ip] = num + 1;
			} else {
				SMPindex[(ic-1)*PEsmpTOT+ip] = num;
			}
		}
	}

	for(ic=1; ic<=NCOLORtot; ic++) {
		for(ip=1; ip<=PEsmpTOT; ip++) {
			j1 = (ic-1) * PEsmpTOT + ip;
			j0 = j1 - 1;
			SMPindex[j1] += SMPindex[j0];
		}
	}

	SMPindexG = (int *)calloc(PEsmpTOT+1, sizeof(int));
	if(SMPindexG == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	nn = ICELTOT / PEsmpTOT;
	nr = ICELTOT - nn * PEsmpTOT;
	for(ip=1; ip<=PEsmpTOT; ip++) {
		SMPindexG[ip] = nn;
		if(ip <= nr) {
			SMPindexG[ip] += 1;
		}
	}

	for(ip=1; ip<=PEsmpTOT; ip++) {
		SMPindexG[ip] += SMPindexG[ip-1];
	}

/*************************************
 * INTERIOR & NEUMANN BOUNDARY CELLs *
 *************************************/
	S1t = MPI_Wtime();
#pragma omp parallel for private (ip, icel, ic0,\
								  icN1, icN2, icN3, icN4, icN5, icN6,\
								  coef, j, ii, jj, kk)
	for(ip=0; ip<PEsmpTOT; ip++) {
		for(icel=SMPindexG[ip]; icel<SMPindexG[ip+1]; icel++) {
			ic0  = NEWtoOLD[icel];

			icN1 = NEIBcell[0][ic0];
			icN2 = NEIBcell[1][ic0];
			icN3 = NEIBcell[2][ic0];
			icN4 = NEIBcell[3][ic0];
			icN5 = NEIBcell[4][ic0];
			icN6 = NEIBcell[5][ic0];

			if(icN5 != 0) {
				icN5 = OLDtoNEW[icN5-1] + 1;
				coef = RDZ * ZAREA;
				D[icel] -= coef;

				if(icN5-1 < icel) {
					for(j=0; j<INL[icel]; j++) {
						if(IAL[icel][j] == icN5) {
							AL[icel][j] = coef;
							break;
						}
					}
				} else {
					for(j=0; j<INU[icel]; j++) {
						if(IAU[icel][j] == icN5) {
							AU[icel][j] = coef;
							break;
						}
					}
				}
			}

			if(icN3 != 0) {
				icN3 = OLDtoNEW[icN3-1] + 1;
				coef = RDZ * YAREA;
				D[icel] -= coef;

				if(icN3-1 < icel) {
					for(j=0; j<INL[icel]; j++) {
						if(IAL[icel][j] == icN3) {
							AL[icel][j] = coef;
							break;
						}
					}
				} else {
					for(j=0; j<INU[icel]; j++) {
						if(IAU[icel][j] == icN3) {
							AU[icel][j] = coef;
							break;
						}
					}
				}
			}

			if(icN1 != 0) {
				icN1 = OLDtoNEW[icN1-1] + 1;
				coef = RDZ * XAREA;
				D[icel] -= coef;

				if(icN1-1 < icel) {
					for(j=0; j<INL[icel]; j++) {
						if(IAL[icel][j] == icN1) {
							AL[icel][j] = coef;
							break;
						}
					}
				} else {
					for(j=0; j<INU[icel]; j++) {
						if(IAU[icel][j] == icN1) {
							AU[icel][j] = coef;
							break;
						}
					}
				}
			}

			if(icN2 != 0) {
				icN2 = OLDtoNEW[icN2-1] + 1;
				coef = RDZ * XAREA;
				D[icel] -= coef;

				if(icN2-1 < icel) {
					for(j=0; j<INL[icel]; j++) {
						if(IAL[icel][j] == icN2) {
							AL[icel][j] = coef;
							break;
						}
					}
				} else {
					for(j=0; j<INU[icel]; j++) {
						if(IAU[icel][j] == icN2) {
							AU[icel][j] = coef;
							break;
						}
					}
				}
			}

			if(icN4 != 0) {
				icN4 = OLDtoNEW[icN4-1] + 1;
				coef = RDZ * YAREA;
				D[icel] -= coef;

				if(icN4-1 < icel) {
					for(j=0; j<INL[icel]; j++) {
						if(IAL[icel][j] == icN4) {
							AL[icel][j] = coef;
							break;
						}
					}
				} else {
					for(j=0; j<INU[icel]; j++) {
						if(IAU[icel][j] == icN4) {
							AU[icel][j] = coef;
							break;
						}
					}
				}
			}

			if(icN6 != 0) {
				icN6 = OLDtoNEW[icN6-1] + 1;
				coef = RDZ * ZAREA;
				D[icel] -= coef;

				if(icN6-1 < icel) {
					for(j=0; j<INL[icel]; j++) {
						if(IAL[icel][j] == icN6) {
							AL[icel][j] = coef;
							break;
						}
					}
				} else {
					for(j=0; j<INU[icel]; j++) {
						if(IAU[icel][j] == icN6) {
							AU[icel][j] = coef;
							break;
						}
					}
				}
			}

			ii = XYZ[0][ic0];
			jj = XYZ[1][ic0];
			kk = XYZ[2][ic0];

			BFORCE[icel] = - (double)(ii + jj + kk) * VOLCEL[ic0];
		}
	}

	E1t = MPI_Wtime();
	fprintf(stderr, "%16.6e sec. (assemble)\n", E1t - S1t);

/****************************
 * DIRICHLET BOUNDARY CELLs *
 ****************************/
/* TOP SURFACE */
	for(ib=0; ib<ZmaxCELtot; ib++) {
		ic0  = ZmaxCEL[ib];
		coef = 2.0 * RDZ * ZAREA;
		icel = OLDtoNEW[ic0-1];
		D[icel] -= coef;
	}

	return 0;
}
