/*
 * POINTER_INIT
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "struct_ext.h"
#include "pcg_ext.h"
#include "pointer_init.h"

#define FNAME "mesh.dat"

extern int
POINTER_INIT(void)
{
	FILE *fp22;
	int i, ii, k;

	if((fp22 = fopen(FNAME, "r")) == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}

	fscanf(fp22, "%d%d%d", &NX, &NY, &NZ);
	fscanf(fp22, "%d", &ICELTOT);

	NEIBcell = (int **)malloc(sizeof(int *)*6);
	if(NEIBcell == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<6; i++) {
		NEIBcell[i] = (int *)malloc(sizeof(int)*ICELTOT);
		if(NEIBcell[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	XYZ = (int **)malloc(sizeof(int *)*3);
	if(XYZ == NULL) {
		fprintf(stderr, "Error: %s\n", strerror(errno));
		return -1;
	}
	for(i=0; i<3; i++) {
		XYZ[i] = (int *)malloc(sizeof(int)*ICELTOT);
		if(XYZ[i] == NULL) {
			fprintf(stderr, "Error: %s\n", strerror(errno));
			return -1;
		}
	}

	for(i=0; i<ICELTOT; i++) {
		fscanf(fp22, "%d", &ii);
		for(k=0; k<6; k++) {
			fscanf(fp22, "%d", &NEIBcell[k][i]);
		}
		for(k=0; k<3; k++) {
			fscanf(fp22, "%d", &XYZ[k][i]);
		}
		fprintf(fp22, "\n");
	}

	fclose(fp22);

	if(DX <= 0.0) {
		DX = 1.0 / (double)NX;
		DY = 1.0 / (double)NY;
		DZ = 1.0 / (double)NZ;
	}

	NXP1 = NX + 1;
	NYP1 = NY + 1;
	NZP1 = NZ + 1;

	IBNODTOT = NXP1 * NYP1;
	N        = NXP1 * NYP1 * NZP1;

	return 0;
}
