      program MAIN

      use STRUCT
      use PCG
      use solver_ICCG_mc
      use solver_ICCG_mc_ft

      implicit REAL*8 (A-H,O-Z)
      real(kind=8), dimension(:), allocatable :: WK

!C
!C +-----------+
!C | init. MPI |
!C +-----------+
!C===
      call MPI_INIT (ierr)
!C===

!C     
!C-- INIT.
      call INPUT
      call POINTER_INIT
      call BOUNDARY_CELL
      call CELL_METRICS
      call POI_GEN

!C 
!C-- MAIN SOLVER
      PHI=  0.d0

      ISET= 0

      allocate (WK(ICELTOT))

      Stime= MPI_WTIME()
      if (METHOD.eq.0) then
        call solve_ICCG_mc                                              &
     &      ( ICELTOT, NL, NU, INL, IAL, INU, IAU, D, BFORCE,           &
     &        PHI, AL, AU, NCOLORtot, PEsmpTOT,                         &
     &        SMPindex, SMPindexG, EPSICCG, ITR, IER)
       else
        call solve_ICCG_mc_ft                                           &
     &      ( ICELTOT, NL, NU, INL, IAL, INU, IAU, D, BFORCE,           &
     &        PHI, AL, AU, NCOLORtot, PEsmpTOT,                         &
     &        SMPindex, SMPindexG, EPSICCG, ITR, IER)
      endif
      Etime= MPI_WTIME()

      write (*,'(//, a, i10)') 'N= ', ICELTOT
      write (*,'(1pe16.6, a)') Etime-Stime, ' sec. (solver)'

      do ic0= 1, ICELTOT
        icel= NEWtoOLD(ic0)
        WK(icel)= PHI(ic0)
      enddo

      do icel= 1, ICELTOT
        PHI(icel)= WK(icel)
      enddo
      call OUTUCD

      call MPI_FINALIZE (ierr)

      stop
      end

