      integer :: PEtot
      integer, dimension(:)  , allocatable :: LEVEL, DOMAIN
      integer, dimension(:)  , allocatable :: OLDtoNEW, NEWtoOLD
      integer, dimension(:,:), allocatable :: NEIBcell, XYZ
      integer, dimension(:,:), allocatable :: ELMindex

      integer, dimension(6) :: NCEL

      character(len= 9 )   ::  fname
!C
!C +-------+
!C | INIT. |
!C +-------+
!C===
      read (*,*) NDX, NDY, NDZ
      read (*,*) NPX, NPY, NPZ
    
      NX= NPX * NDX
      NY= NPY * NDY
      NZ= NPZ * NDZ

      ICELTOT= NX  * NY  * NZ
      PEtot  = NPX * NPY * NPZ

      NXP1= NX + 1
      NYP1= NY + 1
      NZP1= NZ + 1

      allocate (NEIBcell(ICELTOT,6), XYZ(ICELTOT,3))      
      allocate (OLDtoNEW(ICELTOT), NEWtoOLD(ICELTOT), LEVEL(ICELTOT))
      allocate (DOMAIN(ICELTOT))

      OLDtoNEW= 0
      NEWtoOLD= 0
      LEVEL= 0
      DOMAIN= 0

      LEVELtot= 4
      allocate (ELMindex(PEtot,0:LEVELtot))
      ELMindex= 0
!C===

!C
!C +-------------------+
!C | INDIVIDUAL REGION |
!C +-------------------+
!C===
      NEIBcell= 0
!C
!C-- NEIGHBORING CELLs
      do k= 1, NZ
        do j= 1, NY
          do i= 1, NX
            icel= (k-1)*NX*NY + (j-1)*NX + i
            NEIBcell(icel,1)= icel - 1
            NEIBcell(icel,2)= icel + 1
            NEIBcell(icel,3)= icel - NX
            NEIBcell(icel,4)= icel + NX
            NEIBcell(icel,5)= icel - NX*NY
            NEIBcell(icel,6)= icel + NX*NY
            if (i.eq. 1) NEIBcell(icel,1)= 0
            if (i.eq.NX) NEIBcell(icel,2)= 0
            if (j.eq. 1) NEIBcell(icel,3)= 0
            if (j.eq.NY) NEIBcell(icel,4)= 0
            if (k.eq. 1) NEIBcell(icel,5)= 0
            if (k.eq.NZ) NEIBcell(icel,6)= 0

            XYZ(icel,1)= i
            XYZ(icel,2)= j
            XYZ(icel,3)= k

          enddo
        enddo
      enddo

!C
!C +-------------+
!C | HID process |
!C +-------------+
!C===

!C
!C-- DOMAIN
      ip  = 0
      do kk= 1, NPZ
      do jj= 1, NPY
      do ii= 1, NPX
        ip= ip + 1
        iS= NX*NY*NDZ*(kk-1)+NX*NDY*(jj-1) + NDX*(ii-1)
        do k0= 1, NDZ
        do j0= 1, NDY
        do i0= 1, NDX
          icel= iS + (k0-1)*NX*NY + (j0-1)*NX + i0
          DOMAIN(icel)= ip          
        enddo
        enddo
        enddo

      enddo
      enddo
      enddo

!C
!C-- LEVEL
      icel= 0
      do k= 1, NZ
      do j= 1, NY
      do i= 1, NX
        icel= icel + 1
        LEVEL(icel)= 1

        ibb= 0
        jbb= 0
        kbb= 0

        if (mod(i,NDX).eq.0.and.i.ne.NX) ibb= 1
        if (mod(j,NDY).eq.0.and.j.ne.NY) jbb= 1
        if (mod(k,NDZ).eq.0.and.k.ne.NZ) kbb= 1

        if (ibb.eq.1) LEVEL(icel)= 2
        if (jbb.eq.1) LEVEL(icel)= 2
        if (kbb.eq.1) LEVEL(icel)= 2

        if (ibb.eq.1.and.jbb.eq.1) LEVEL(icel)= 3
        if (jbb.eq.1.and.kbb.eq.1) LEVEL(icel)= 3
        if (kbb.eq.1.and.ibb.eq.1) LEVEL(icel)= 3
        
        if (ibb.eq.1.and.jbb.eq.1.and.kbb.eq.1) LEVEL(icel)= 4

      enddo
      enddo
      enddo

!C
!C-- RENUMBERING
      ip  = 0
      icou= 0

      do kk= 1, NPZ
      do jj= 1, NPY
      do ii= 1, NPX
        ip= ip + 1
        iS= NX*NY*NDZ*(kk-1)+NX*NDY*(jj-1) + NDX*(ii-1)
        iS0= (NDX*NDY*NDZ)*(ip-1)

        ELMindex(ip,0)= iS0
        do lev= 1, 4
          lcou= 0
          do k0= 1, NDZ
          do j0= 1, NDY
          do i0= 1, NDX
            icel= iS + (k0-1)*NX*NY + (j0-1)*NX + i0
            if (lev.eq.LEVEL(icel)) then
              icou= icou + 1
              lcou= lcou + 1
              OLDtoNEW(icel)= icou
              NEWtoOLD(icou)= icel
            endif
          enddo
          enddo
          enddo
          ELMindex(ip,lev)= ELMindex(ip,lev-1) + lcou
        enddo

      enddo
      enddo
      enddo
!C===
             
!C
!C-- POST processing
      ipe= 1
      open (21, file= 'mesh.dat', status='unknown', form='formatted')

      write (21,'(10i10)') NX, NY, NZ
      write (21,'(10i10)') ICELTOT
      write (21,'(10i10)') PEtot, LEVELtot

      do ip= 1, PEtot 
        write (21,'(10i10)') (ELMindex(ip,lev), lev= 0, LEVELtot)
      enddo

      do i0= 1, ICELTOT
        i= NEWtoOLD(i0)
        do k= 1, 6
          neib= NEIBcell(i,k)
          if (neib.eq.0) then
            NCEL(k)= 0
           else
            NCEL(k)= OLDtoNEW(neib)
          endif
        enddo
        write (21,'(12i10)') i0, (NCEL(k), k= 1, 6), (XYZ(i,j), j=1,3), 
     &                       DOMAIN(i), LEVEL(i)
      enddo

      close (21)
!C===
      stop
      end
