!C
!C***
!C*** POINTER_INIT
!C***
!C
      subroutine POINTER_INIT

      use STRUCT
      use PCG

      implicit REAL*8 (A-H,O-Z)

      character*9 fname

!C
!C +------+
!C | GRID |
!C +------+
!C===
      open (21, file= 'mesh.dat', status='unknown', form='formatted')

      read (21,'(10i10)') NX , NY , NZ
      read (21,'(10i10)') ICELTOT
      read (21,'(10i10)') nnn, LEVELtot

      if (nnn.ne.PEsmpTOT) then
        write (*,*) "###ERROR### inconsistent thread number !!"
        call MPI_ABORT (MPI_COMM_WORLD, ierr)
      endif

      allocate (NEIBcell(ICELTOT,6), XYZ(ICELTOT,3))
      allocate (ELMindex(PEsmpTOT,0:LEVELtot))
      allocate (DOMAIN(ICELTOT), LEVEL(ICELTOT))
      allocate (NEWtoOLD(ICELTOT))

!$omp parallel do private (ip, lev)
      do ip = 1, PEsmpTOT
      do lev= 0, LEVELtot
        ELMindex(ip,lev)= 0
      enddo
      enddo

      do ip= 1, PEsmpTOT
        read (21,'(10i10)') (ELMindex(ip,lev), lev= 0, LEVELtot)
      enddo

      do i= 1, ICELTOT
        read (21,'(12i10)') ii, (NEIBcell(i,k), k= 1, 6),               &
     &                          (XYZ     (i,j), j= 1, 3),               &
     &                           DOMAIN(i), LEVEL(i)
        ii= XYZ(i,1)
        jj= XYZ(i,2)
        kk= XYZ(i,3)
        ic0= (kk-1)*NX*NY + (jj-1)*NX + ii
        NEWtoOLD(i)= ic0
      enddo
      close (21)

      if (DX.le.0.0e0) then
        DX= 1.d0 / dfloat(NX)
        DY= 1.d0 / dfloat(NY)
        DZ= 1.d0 / dfloat(NZ)
      endif

      NXP1= NX + 1
      NYP1= NY + 1
      NZP1= NZ + 1

      IBNODTOT= NXP1 * NYP1
      N       = NXP1 * NYP1 * NZP1
!C===
      return
      end



