      program MAIN

      use STRUCT
      use PCG
      use solver_ICCG_mc

      implicit REAL*8 (A-H,O-Z)
      real(kind=8), dimension(:), allocatable :: WK

!C
!C +-----------+
!C | init. MPI |
!C +-----------+
!C===
      call MPI_INIT (ierr)
!C===

!C     
!C-- INIT.
      call INPUT
      call POINTER_INIT
      call BOUNDARY_CELL
      call CELL_METRICS
      call POI_GEN

!C 
!C-- MAIN SOLVER
      ISET= 0

      allocate (WK(ICELTOT))

      Stime= MPI_WTIME()
        call solve_ICCG_mc                                              &
     &      ( ICELTOT, NL, NU, INLnew, IALnew, INUnew, IAUnew,          &
     &        D, BFORCE, PHI, ALnew, AUnew, NCOLORtot, PEsmpTOT,        &
     &        SMPindex_new, EPSICCG, ITR, IER)
      Etime= MPI_WTIME()

      write (*,'(//, a, i10)') 'N= ', ICELTOT
      write (*,'(1pe16.6, a)') Etime-Stime, ' sec. (solver)'

      do ic0= 1, ICELTOT
        icel= NEWtoOLDnew(ic0)
        WK(icel)= PHI(ic0)
      enddo

      do icel= 1, ICELTOT
        PHI(icel)= WK(icel)
      enddo
      call OUTUCD

      call MPI_FINALIZE (ierr)

      stop
      end

