      implicit REAL*8 (A-H,O-Z)
      include 'mpif.h'
      real(kind=8), dimension(:), allocatable :: X, Y
      real(kind=8), dimension(:), allocatable :: Z1, Z2
      real(kind=8), dimension(:), allocatable :: Z3, Z4, Z5
      integer, dimension(0:2) :: INDEX
!C
!C +------+
!C | INIT |
!C +------+
!C===
      call MPI_INIT (ierr)

      write (*,*) 'N, nopt ?'
      read  (*,*)  N, nopt

      allocate (X(N), Y(N), Z1(N), Z2(N), Z3(N), Z4(N), Z5(N))

      if (nopt.eq.0) then
        X = 1.d0
        Y = 1.d0
        Z1= 0.d0
        Z2= 0.d0
        Z3= 0.d0
        Z4= 0.d0
        Z5= 0.d0
       else
!$omp parallel do private (i)
        do i= 1, N
          X (i)= 0.d0
          Y (i)= 0.d0
          Z1(i)= 0.d0
          Z2(i)= 0.d0
          Z3(i)= 0.d0
          Z4(i)= 0.d0
          Z5(i)= 0.d0
        enddo
!$omp end parallel do
      endif

      ALPHA= 1.d0
!C===

!C
!C +-------+
!C | DAXPY |
!C +-------+
!C===
      S2time= MPI_WTIME()
!$omp parallel do private (i)
        do i= 1, N
          Z1(i)= ALPHA*X(i) + Y(i)
          Z2(i)= ALPHA*X(i) + Y(i)
          Z3(i)= ALPHA*X(i) + Y(i)
          Z4(i)= ALPHA*X(i) + Y(i)
          Z5(i)= ALPHA*X(i) + Y(i)
        enddo
!$omp end parallel do
      E2time= MPI_WTIME()

      write (*,'(/a)')          '# DAXPY'
      write (*,'( a, 1pe16.6)') '  omp-1 ', E2time - S2time
!C===

!C
!C +-----+
!C | DOT |
!C +-----+
!C===
      V1= 0.d0
      V2= 0.d0
      V3= 0.d0
      V4= 0.d0
      V5= 0.d0
      S2time= MPI_WTIME()
!$omp parallel do private(i) reduction (+:V1,V2,V3,V4,V5)
        do i= 1, N
          V1= V1 + X(i)*(Y(i)+1.d0)
          V2= V2 + X(i)*(Y(i)+2.d0)
          V3= V3 + X(i)*(Y(i)+3.d0)
          V4= V4 + X(i)*(Y(i)+4.d0)
          V5= V5 + X(i)*(Y(i)+5.d0)
        enddo
!$omp end parallel do
      E2time= MPI_WTIME()

      write (*,'(/a)')          '# DOT'
      write (*,'( a, 1pe16.6)') '  omp-1 ', E2time - S2time
!C===
      call MPI_FINALIZE (ierr)
      stop
      end
